
uniform sampler3D RayleighDeltaSTexture, MieDeltaSTexture;

flat in int layer;

layout(location = 0) out vec4 inscatter_out;

void main() {
    vec3 uvw = vec3(gl_FragCoord.xy, float(layer) + 0.5) / vec3(ivec3(RES_MU_S * RES_NU, RES_MU, RES_R));
	
    vec4 ray = texture(RayleighDeltaSTexture, uvw);
    vec4 mie = texture(MieDeltaSTexture, uvw);
	
	inscatter_out = vec4(ray.rgb, mie.r); // store only red component of single Mie scattering (cf. "Angular precision")
}
