
layout(triangles) in;
layout(triangle_strip, max_vertices = 96) out;

uniform int RES_R;
uniform float Rg, Rt;

flat out int layer;
flat out float r;
flat out vec4 dhdH;

void main() {
	
	for (int l = 0; l != RES_R; ++l) {
		float rl = float(l) / (float(RES_R) - 1.0);
		rl = sqrt(Rg * Rg + rl * rl * (Rt * Rt - Rg * Rg));
		
		// why?
		if (l == 0) {
			rl += 0.01;
		} else if (l == RES_R - 1) {
			rl -= 0.001;
		}
		
		float dmin = Rt - rl;
		float dmax = sqrt(rl * rl - Rg * Rg) + sqrt(Rt * Rt - Rg * Rg);
		float dminp = rl - Rg;
		float dmaxp = sqrt(rl * rl - Rg * Rg);
		
		layer = l;
		r = rl;
		dhdH = vec4(dmin, dmax, dminp, dmaxp);
		
		gl_Layer = l;
		
		for (int i = 0; i != gl_in.length(); ++i) {
			gl_Position = gl_in[i].gl_Position;
			EmitVertex();
		}
		
		EndPrimitive();
	}
}
