
float opticalDepth(in float H, in float r, in float mu) {
	if (mu < -sqrt(1.0 - (Rg / r) * (Rg / r))) {
		return 1e9;
	}
	
	float dx = limit(r, mu) / float(TRANSMITTANCE_INTEGRAL_SAMPLES);
    float yi = exp(-(r - Rg) / H);
	
    float result = 0.0;
    for (int i = 1; i <= TRANSMITTANCE_INTEGRAL_SAMPLES; ++i) {
        float xj = float(i) * dx;
        float yj = exp(-(sqrt(r * r + xj * xj + 2.0 * xj * r * mu) - Rg) / H);
		
        result += (yi + yj) / 2.0 * dx;
        
		yi = yj;
    }
    return result;
}

layout(location = 0) out vec3 transmittance_out;

void main() {
	
	float r, muS;
	getTransmittanceRMu(r, muS);
	
    vec3 depth = betaR * opticalDepth(HR, r, muS) + betaMEx * opticalDepth(HM, r, muS);
	
	transmittance_out = exp(-depth);
}
