
layout(quads, fractional_odd_spacing, ccw) in;

uniform mat4 ModelViewMatrix;
uniform mat4 ModelViewProjectionMatrix;

uniform sampler2D OffsetsTexture;

out vec2 VTexCoords;
out vec3 VPosition;
out vec2 VDepthPos;

void main()
{
	VTexCoords = gl_TessCoord.xy;
	
	
	// get position passed from tess control shader
	vec2 a = mix(gl_in[0].gl_Position.xz, gl_in[1].gl_Position.xz, gl_TessCoord.x);
	vec2 b = mix(gl_in[3].gl_Position.xz, gl_in[2].gl_Position.xz, gl_TessCoord.x);
	vec2 base_position_xz = mix(a, b, gl_TessCoord.y);
	vec3 base_position = vec3(base_position_xz.x, 0.0, base_position_xz.y);
	
	
	// apply offset to position
	vec3 offset = texture(OffsetsTexture, gl_TessCoord.xy).xyz;
	vec3 offset_position = base_position + offset;
	
	VPosition = offset_position;
	
	
	vec4 pos = ModelViewProjectionMatrix * vec4(offset_position, 1.0);
	gl_Position = pos;
	
	VDepthPos = pos.zw;
}
