
declare_globals{
	"fonts",
	"new_font",
	
	"shaders",
	"new_shader",
	
	"textures",
	"new_texture",
}

local function warn_if_nil(val, text)
	if val == nil then
		warning(text)
	end
end


fonts = {}

function new_font(f)
	f = f or {}
	
	warn_if_nil(f.file)
	warn_if_nil(f.size)
	
	f.file = dirs.assets.."fonts/"..f.file
	
	return f
end


shaders = {}

function new_shader(s)
	s = s or {}
	
	for k,v in ipairs(s) do
		s[k] = dirs.assets.."shaders/"..v
	end
	
	return s
end


textures = {}

function new_texture(t)
	t = t or {}
	
	warn_if_nil(t.file)
	
	t.file = dirs.assets.."textures/"..t.file
	
	-- TODO: texture settings
	
	return t
end

