
declare_globals{
	"print",
	"error",
	"warning",
	"exists",
}

-- Direct the print function to the C++ printing function (via tostring).
local print = c_print
_G.print = function(s)
    print(tostring(s))
end
c_print = nil

-- Change the standard error function so that it shows the debug traceback.
local error = error
_G.error = function(m, l)
    error("\nerror msg: "..m.."\n"..debug.traceback(), (l or 1) + 1)
end

warning = function(m)
	print("<warning> LUA_WARNING: "..m)
	print(debug.traceback())
end

-- Check whether a file exists.
function exists(n)
    local f = io.open(n)
    if (f == nil) then
		return false
	end
    io.close(f)
    return true
end
