
declare_globals{
	"load_file",
	"save_file",
}

function load_file(f)
	-- save the current thread env
	local oldfe = getfenv(0)
	local newfe = {}
	-- hide the globals metatable (stops global variable protection)
	local gmt = getmetatable(_G)
	setmetatable(_G, nil)
	-- set new thread env (globals still accessible, but new values go in newfe)
	setmetatable(newfe, {__index = _G})
	setfenv(0, newfe)
	
	if exists(f) then
		dofile(f)
	else
		error("File: "..f.." does not exist!")
	end
	
	-- restore old thread env
	setfenv(0, oldfe)
	setmetatable(newfe, nil)
	-- restore globals metatable
	setmetatable(_G, gmt)
	return newfe
end

function save_file(f, t, mode)
	local fh = io.open(f, mode or "w")
	if not fh then
		error("Could not open file: "..f)
	end
	
	for k,v in pairs(t) do
		if type(k) ~= "string" then
			error("Non string key value at root level.")
		end
		
		fh:write(tprint(k, v))
	end
	fh:close()
end
